//+------------------------------------------------------------------+
//|                                                Test 5 Minute.mq4 |
//+------------------------------------------------------------------+

extern double  Lots = 0.1;
extern int     Slippage = 2;
extern int     MaxTrades = 1;     // Maximum number of simultaneous lots that can be opened.

double         XO_LTGRN = 0;      // (0) Value of light green XO uptrend bar.
double         XO_GRN = 0;        // (2) Value of green XO uptrend bar.
double         XO_LTRED = 0;      // (1) Value of light red XO downtrend bar.
double         XO_RED = 0;        // (3) Value of red XO downtrend bar.
double         PrevTime = 0;      // Temporary storage of time so execution will be once per Bar.

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
    return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
    return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
    if(PrevTime == Time[0]) return(0);    
    
    XO_LTGRN = iCustom(NULL,0,"ZZ 4 TF XO",0,0);
    XO_GRN = iCustom(NULL,0,"ZZ 4 TF XO",2,0);
    XO_LTRED = iCustom(NULL,0,"ZZ 4 TF XO",1,0);
    XO_RED = iCustom(NULL,0,"ZZ 4 TF XO",3,0);

    //Print("XO_LTRED = ",XO_LTRED," and XO_RED = ",XO_RED,".");
    
   
    if (OrdersTotal() < 1 && ((XO_LTGRN >= 1 ) || (XO_GRN == 4)))
    {
        TradeBuy();    
    }
    
    
    if (OrdersTotal() > 0 && XO_RED == -4)
    {
        TradeCloseBuy();
    }
    PrevTime = Time[0];
//----------------------------------------------------------------------------------
//                                 END OF MAIN PROGRAM    
//----------------------------------------------------------------------------------
    return(0);
}
//----------------------------------------------------------------------------------
//                                         BUY
//----------------------------------------------------------------------------------
    void TradeBuy()         // SEE IF A 'Buy' TRADE CAN BE OPENED, AND, IF SO, DO IT.
    {
        if(OrdersTotal() < MaxTrades)
            OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, 0, 0, NULL, 0, 0, Blue);
        return(0);		    
    }   
//-----------------------------------------------------------------------------------
//                                     CLOSE BUY
//-----------------------------------------------------------------------------------
   void TradeCloseBuy()   // CLOSE ALL OPEN 'Buy' TRADES.
	{
      int cnt;    
      for(cnt = OrdersTotal(); cnt >= 0; cnt--)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if(OrderSymbol() == Symbol()) 
         {
            if(OrderType() == OP_BUY)
               OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Blue);
            }
      }
      return(0);
   }

       